drop database demos
go

create database demos
go

use demos
go

-- fails
create assembly unsafeasm
 from 'c:\temp\unsafeasm.dll'
 with permission_set = unsafe
go

USE MASTER 
go

-- create asymmetric key
-- fails unless database master key in master
CREATE ASYMMETRIC KEY bobsnk
 FROM FILE = 'c:\temp\bob.snk'
go

-- create one like this
-- CREATE MASTER KEY ENCRYPTION BY PASSWORD = 'StrongPW1'
-- go

-- catalog again
-- NOTE: you can't catalog the same asymmetric key twice
-- with different SQL Server names
-- CREATE ASYMMETRIC KEY bobsnk2
-- FROM FILE = 'c:\temp\bob.snk'
-- go

CREATE LOGIN bobsnk FROM ASYMMETRIC KEY bobsnk
GO

GRANT UNSAFE ASSEMBLY to bobsnk
go

use demos
go

create assembly unsafeasm
 from 'c:\temp\unsafeasm.dll'
 with permission_set = unsafe
go

create function add2 (
 @a int,
 @b int)
RETURNS int
EXTERNAL NAME unsafeasm.[UnsafeAsm.Class1].add2
go

print dbo.add2(1,1)

USE MASTER
GO

-- reset 
DROP LOGIN bobsnk
GO

DROP ASYMMETRIC KEY bobsnk
GO

DROP DATABASE demos
GO

USE demos
go

print dbo.add2(1,1)
